function test_vals = bagging_pred(U, data, model, uparam, nbag, bagsz, testind)
    %% variable initialization
    nvec = size(data.Y);
    nmod = length(nvec);
    nzind0 = find(data.Y);
    test_vals_all = zeros(size(testind,1), nbag);
    model2 = model;
    %let us first use uniform strategy for bagging prediction
    model2.sample_strategy = 'uniform';
    for iter=1:nbag       
        %sample a sub-tensor
        [subind, ~] = sub_sample(data.Y, nvec, bagsz, model2);
        for k=1:nmod
            subind{k} = union(subind{k},testind(:,k));
        end
        nzind = nzind0;
        for k=1:nmod
            nzind = nzind( ismember(nzind(:,k),subind{k}),:);
            if isempty(nzind) 
                break; 
            end
        end
        if isempty(nzind)
            continue;
        else
            rmap = cell(nmod,1);
            sub_ind = zeros(size(nzind));
            test_ind = zeros(size(testind));
            sub_sz = zeros(size(bagsz));
            for j=1:nmod
                rmap{j} = zeros(max(subind{j}),1);
                sub_sz(j) = length(subind{j});
                rmap{j}(subind{j}) = 1:sub_sz(j);
                sub_ind(:,j) = rmap{j}(nzind(:,j));
                test_ind(:,j) = rmap{j}(testind(:,j));
            end
            Y_sub = sptensor(sub_ind, data.Y(nzind), sub_sz);
        end    
        U_sub = cell(length(U),1);
        for k=1:nmod
            U_sub{k} = U{k}(subind{k},:);
        end 
        if strcmp(model.loss, 'Gauss') || isempty(nzind)
            M_sub = Y_sub;
        else
            P = tucker_als(Y_sub, model.dim);
            M_sub = ttm(P.core,P.U); 
            M_sub = M_sub/norm(M_sub)*norm(Y_sub); %    
        end
        for k=1:nmod
            U_sub{k} = U{k}(subind{k},:);
        end

        %E-step to update local varaitional parameters q(M_sub)
        kernel = ten_ker_func(U_sub, uparam);
        M_sub = update_qM(M_sub, Y_sub, kernel, model);
        test_vals_all(:,iter) = M_sub(test_ind);
    end
    test_vals = mean(test_vals_all,2);
end