function [val, name] = eval_performance(model, data, M)
   name = 'mse';
   if strcmp(model.loss, 'poisson-exp')
      expt = tenfun(@(x) exp(x), M);
      val = mean((data.Ymiss- expt(data.subs)).^2);
   elseif strcmp(model.loss, 'possion-trunc') 
      M_trunc = M.*tenfun(@ge,M,0);
      val = mean((data.Ymiss- M_trunc(data.subs)).^2);
   elseif strcmp(model.loss, 'Gauss')
      val = mean((data.Ymiss - M(data.subs)).^2);
   elseif strcmp(model.loss, 'Probit')            
      [~,~,~,val] = perfcurve(data.Ymiss, M(data.subs), 1);
      name = 'auc';
   end         
end