clear all;
close all;


%1. generate training and test sets
%   training: 80% nz idx for training
%   testing: 50 testsets, each test has 200 nonzeros, 2000 zeros
%2. generate subtensors
%3. generate initialization


data = load('./big/dblp-tensor.txt');
data = data + 1;
nzind = data(:,1:3);
nvec = [10000,200,10000];
nmod = length(nvec);
Y = sptensor(nzind,ones(length(nzind),1), nvec);
portion = ceil(length(nzind)*0.2);
idx = datasample(1:length(nzind), portion, 'Replace', false);
test_ind = nzind(idx,:);
ridx = setdiff(1:length(nzind), idx);
train_ind = nzind(ridx,:);
data = [];
data.nzind = train_ind;
data.test_ind_all = test_ind;
data.size = nvec;
%generate 50 datasets, each contains 200 1s and 1800 0s
data.test = {};
for k=1:50
    %1s
    idx = datasample(1:length(test_ind), 200, 'Replace', false);
    ymiss = ones(200,1);
    subs = test_ind(idx,:);
    %0s
    subs0 = zeros(5000,nmod);
    for d=1:nmod
        subs0(:,d) = datasample(1:nvec(d),5000);        
    end
    idx = tt_sub2ind(nvec,subs0);
    idx = unique(idx);
    vals = Y(idx);
    idx = idx(vals==0);
    idx = idx(1:1800);
    subs0 = tt_ind2sub(nvec,idx);
    subs = [subs;subs0];
    ymiss = [ymiss; zeros(1800,1)];
    data.test{k} = [];
    data.test{k}.subs = subs;
    data.test{k}.Ymiss = ymiss;
    dt = [subs, ymiss];
    save(['./dblp/dblp-test-', num2str(k),'.mat'],'dt');    
end
data.Y = sptensor(train_ind, ones(length(train_ind),1), nvec);
save('./dblp/dblp.mat','data');





       