%p: mixture proportions, components: each row is a center, n, number of
%data points; v: variance
function [data, label] = sample_gmm(p, components, n, v)
    d = size(components,2);
    data = zeros(n, d);
    label = zeros(n,1);
    x = mnrnd(1, p, n)>0;
    for j=1:n
        label(j) = find(x(j,:));
        mean = components(x(j,:), :);
        data(j,:) = mvnrnd(mean, v*eye(d),1);
    end
end