function [ret, log_prob] = sub_sample(data, nvec, sz, model)
    nonzero_ind = find(data);
    ret = cell(size(nonzero_ind,2),1);
    log_prob = 0.0;
    nmode = size(nonzero_ind,2);
    switch model.sample_strategy
        case 'weighted'
            for k=1:nmode
                ret{k} = datasample(1:nvec(k), sz(k), 'Replace', false, 'Weights', model.weight{k});                
            end
        case 'weighted2'    
            for k=1:nmode
                ret{k} = datasample(1:nvec(k), sz(k), 'Replace', false, 'Weights', model.weight{k});                
            end
            %how to calc prob is a problem
        case 'uniform'
            %independent sampling in each mode with equal prob. for each
            %node           
            for k=1:nmode
                indk = 1:nvec(k);
                perm = randperm(length(indk));
                ret{k} = perm(1:sz(k));
                log_prob = log_prob - sum(log(length(indk) - sz(k)+1:length(indk)));
            end
        case 'grid'
            repeat = length(model.partition);
            r = randsample(repeat,1);
            for k = 1:nmode
                grid_id = randsample(model.par_num{k},1);
                ret{k} = find(model.partition{r}{k}==grid_id);
                if length(ret{k})> model.subtensor_size(k)
                    ind = randsample(length(ret{k}), model.subtensor_size(k));
                    ret{k} = ret{k}(ind);
                end
            end
        otherwise
            error('sub_sample: unknown sampling strategy');
    end
end
