function [obj, g] = ten_gradU(Ukvec, k, Utimsnok, eigVals, eigVec_k, uparam, model)
% Uk is a vector
% U is a cell
% M is a tensor
nvec = size(Utimsnok); %n = n1*n2*...*nK
n = prod(nvec); 
n_k = nvec(k);
nmod = length(nvec);
nd = length(Ukvec);
d = nd/ n_k;
U_k = reshape(Ukvec, n_k, d);
% gradient vector initialization
g = zeros(nd,1);
g = g + Ukvec*model.dp_lam(k);
gpart = model.stat.dp_phi{k}*model.stat.eta_mean{k};
g = g - model.dp_lam(k)*gpart(:);

% calculate new kernel function
kernel_k = ker_func(U_k, uparam);
tmp1 = sptensor(ttm(Utimsnok, kernel_k.V*diag(kernel_k.D.^(-0.5))*(kernel_k.V)', k));
KV = invmat(kernel_k.K, eigVec_k);
DD =  tensor(ktensor(eigVals));
tau = 1;
DD =  DD./(tau+DD);
VtSigmaV = eigVals;
for i =1: nmod
    VtSigmaV{i} = 1./(eigVals{i}); 
end
VtSigmaV{k} = diag( eigVec_k'* KV);


% log-likelihood
obj = 0.5*n/n_k * sum(log(kernel_k.D)) + 0.5 *tau* norm(tmp1)^2 ...
    + 0.5 *tau* ttv(DD,VtSigmaV);

tmp = tenmat(Utimsnok,k);
KM = invmat(kernel_k.K, (tmp.data*tmp.data'));
modarr = setdiff(1:nmod, k);

% gradient
if strcmp(kernel_k.type, 'tapcov')
    [Ugrad ]= taperCovgrad(U_k, uparam);
end

K = kernel_k.K;
for j = 1:d
    repU = repmat(U_k(:,j), 1, n_k);
    switch kernel_k.type
        case 'rbf'
            Kd = -2 * uparam.weight* kernel_k.gamma * (kernel_k.K \ (kernel_k.K .* (repU' - repU)));
        case 'exp'
            Kd = - uparam.weight* kernel_k.gamma * (kernel_k.K \ (kernel_k.K ...
                .* (-1/kernel_k.gamma*log(K)).^(-0.5).*(repU' - repU)));
        case 'poly'
            Kd = kernel_k.degree * kernel_k.K \ ...
                (kernel_k.K ./ (U_k*U_k') .* (repU + diag(U_k(:,j)))); %zsd-wrong, U not defined, U_k*U_k'
        case 'linear'
            Kd = kernel_k.K \ (repU + diag(U_k(:,j))); %zsd-wrong:  Kd = kernel_k.K \ (repU );
        case 'tapcov'
            Kd=  invmat(kernel_k.K, Ugrad{j});
        otherwise
            error('gradU: unknown kernel type');
    end

    indg = (j-1)*n_k+1:j*n_k;
    g(indg) = g(indg) + n/n_k * diag(Kd) - tau*dot(KM', Kd)'; 
    
    
    tmpD = ttv(DD,VtSigmaV ,modarr);
    g(indg) = g(indg) - tau*((tmpD.data)'* (KV'.*(eigVec_k'*Kd)))'; 

end

switch uparam.norm_reg
    case 1
        g = g + uparam.kreg;
    case 2
        g = g + uparam.kreg* U_k(:);
end
% regularization
if uparam.norm == 1
    g = g / norm(g);
end
g = real(g);

