function [U] = tensor_exp_alog(model, optimizer, uparam)
    nfold = 5;
    model.dim = 3;
    for i = 1: nfold
        data = load(strcat(strcat('./small/alog_fold',num2str(i)),'.mat'));
        data = data.data;
        %test values
        sz = [200,100,200];
        %sz = [581,124,48];
        %sz = [203, 203, 200]; %enron
        data.sz = sz;
        data.Y = tenfun(@log, tensor(data.Y) + 1);
        data.train = find(data.Y~=0);
        data.Ymiss = log(data.test_vals+1);
        data.subs = data.test_ind;
        data.eval_verbose = 1;

        nmod = length(size(data.Y));
        U = cell(nmod,1);
        for j = 1:nmod
            U{j} = nvecs(data.Y, j, model.dim); 
        end
        model.U = U;
        model.M = tensor(data.Y);
        model.rate = 1e-6;
        model.dp_lam = 100*[1,1,1];
        model.update_inv_cov = 0;
        model.loss = 'Gauss';
        model.stream_total = 500;
        model.subtensor_size = [40 40 40];
        model.var_total = 5;
        model.enable_dp = 1;
        
        model.update_scheme = 1;
        model.sample_strategy = 'weighted'; %'uniform';
        
        uparam.type = 'rbf';
        uparam.kreg = 1e-2;       
        uparam.gamma = 1;
        uparam.weight = 1;
        
        [U, model] = InfTuckerDP_vem_online(data, model, uparam);
        %test with bagging
        test_vals = [];
        segments = 0:100:size(data.subs,1);
        if segments(end) ~= size(data.subs, 1)
            segments = [segments, size(data.subs,1)];
        end
        for j=1:length(segments)-1
            subset = segments(j)+1:segments(j+1);
            if ~isempty(subset)
                test_vals_subset = bagging_pred(U, data, model, uparam, 10, [40,40,40], data.subs(subset,:));
                test_vals = [test_vals; test_vals_subset];
            end
            if mod(j,20) == 0
                fprintf('segment %d\n',j);
            end
        end
        name = 'mse';
        val = mean((test_vals - data.Ymiss).^2);       
        fprintf('fold = %d dim = %d, InfTucker-DP-online, %s = %g\n', i, model.dim, name, val);
        
        
        kernel = ten_ker_func(U, uparam);
        [Mtest] = update_qM(model.M, data.Y, kernel, model);
        [val, name] = eval_performance(model, data, Mtest);            
        fprintf('nobagging, %s = %g\n', name, val);               
    end
end
