function [U] = tensor_exp_dblp_large_w(model, optimizer, uparam)
    data = load('./dblp/dblp.mat');
    data = data.data;
    data.train = data.nzind;
    %test values
    %sz = [200,100,200];
    %data.Ymiss = data.test_vals;
    %data.subs = data.test_ind;          
    data.eval_verbose = 0;
    model.dim = 3;
    nmod = length(size(data.Y));
    U = cell(nmod,1);
    for j = 1:nmod
        U{j} = nvecs(data.Y, j, model.dim); 
    end

    model.U = U;
    model.M = data.Y;
    model.rate = 1e-8;
    model.dp_lam = 10*[1,1,1]; 
    %model.rate = 1e-6;
    model.update_inv_cov = 0;
    model.loss = 'Gauss';
    model.stream_total = 10240;
    model.subtensor_size = [125 125 125];
    model.var_total = 5;
    model.sigma2 = 0.1;
    model.T = [100,10, 100];
    %model.sigma2 = 1; %very bad
    %key setting, whether enable DP prior
    model.enable_dp = 1;
    model.sample_strategy = 'weighted2';
    model.cache_stat = true;


    uparam.type = 'rbf';
    uparam.gamma = 1;
    uparam.weight = 1;
    uparam.kreg = 1e-6;
    %uparam.kreg = 1;%will bevery bad
    [U, model] = InfTuckerDP_vem_online(data, model, uparam);        
    save(['dblp-w-U-',num2str(model.stream_total),'.mat'],'U');

    %load('dblp-U-200.mat','U');
    test_n = 50;
    auc = zeros(test_n,1);
    for k=1:test_n
        test_vals = [];
        segments = 0:100:size(data.test{k}.subs,1);
        if segments(end) ~= size(data.test{k}.subs, 1)
            segments = [segments, size(data.test{k}.subs,1)];
        end
        for j=1:length(segments)-1
            subset = segments(j)+1:segments(j+1);
            if ~isempty(subset)
                test_vals_subset = bagging_pred(U, data, model, uparam, 10, [100,100,100], data.test{k}.subs(subset,:));
                test_vals = [test_vals; test_vals_subset];
            end
            fprintf('segment %d\n',j);
        end
        name = 'auc';
        %val = mean((test_vals - data.Ymiss).^2); 
        [~,~,~,auc(k)] = perfcurve(data.test{k}.Ymiss, test_vals, 1);
        fprintf('data %d, %s = %g\n', k, name, auc(k));
    end
    fprintf('average auc = %g (%g)\n', mean(auc), std(auc)/sqrt(length(auc)));
    
