function [U] = tensor_exp_digg(model, optimizer, uparam)
    nfold = 5;
    model.dim = 3;
    for i = 1: nfold
        data = load(strcat(strcat('./small/digg1_fold_',num2str(i)),'.mat'));
        data = data.dt;
        %test values
        sz = [581,124,48];
        %sz = [203, 203, 200]; %enron
        data.sz = sz;
        data.Y = sptensor(data.train(1:end,1:end-1),data.train(1:end,end),sz);
        data.Ymiss = data.test(:, end);
        data.subs = data.test(:, 1:end-1);
        data.eval_verbose = 1;

        %inftucker    
        P = tucker_als(data.Y, model.dim);
        %initialization using tucker
        model.U = P.U;
        model.M = tensor(data.Y);
        model.rate = 1e-7; %0.2*1e-7;
        model.dp_lam = 1e3*ones(size(sz));
        model.loss = 'Probit';
        model.update_inv_cov = 0;
        model.var_total = 20;
        model.subtensor_size = [40 40 40];
        model.stream_total = 500;%ceil(prod(sz)/prod(model.subtensor_size));
        model.enable_dp = 1;
        model.update_scheme = 1;
        model.sample_strategy = 'weighted'; %'weighted';
        
        uparam.type = 'rbf';
        uparam.kreg = 1;       
        uparam.gamma = 1;
        uparam.weight = 1;
        
        %parameter for tap-cov
%         uparam.type = 'tapcov';
%         uparam.nu = 0.5;
%         uparam.alpha = 1;
%         uparam.phi = 1;
%         uparam.theta = 1;        
%         uparam.decision = 1e-8;
%         uparam.distance = 'Euclidean';
%         uparam.taper = 'Spherical';
        
        %InfTucker DP (without online)
        %[U, M, model] = InfTuckerDP_vem(data, model, optimizer, uparam);
        %[val1(i), name] = eval_performance(model, data, M);
        %InfTucker DP online learning
        [U, model] = InfTuckerDP_vem_online(data, model, uparam);
        %test with bagging
        test_vals = [];
        segments = 0:100:size(data.subs,1);
        if segments(end) ~= size(data.subs, 1)
            segments = [segments, size(data.subs,1)];
        end
        for j=1:length(segments)-1
            subset = segments(j)+1:segments(j+1);
            if ~isempty(subset)
                test_vals_subset = bagging_pred(U, data, model, uparam, 10, [40,40,40], data.subs(subset,:));
                test_vals = [test_vals; test_vals_subset];
            end
            fprintf('segment %d\n',j);
        end
        name = 'auc';
        [~,~,~,val] = perfcurve(data.Ymiss, test_vals, 1);                
        fprintf('fold = %d, InfTucker-DP-online, %s = %g\n', i, name, val);
        
        %test without bagging
        kernel = ten_ker_func(U, uparam);
        [Mtest] = update_qM(model.M, data.Y, kernel, model);
        [val, name] = eval_performance(model, data, Mtest);
        fprintf('without bagging, %s = %g\n', name, val);                
    end
end
