function [ Yobs_arr, index_obs_arr, Ymiss_arr, index_miss_arr ] = tensor_split(Yname, options)

% load data, Y is a sparse tensor
Y = load(Yname);
nvec = size(Y);
[num_nz, num_mode] = size(Y.subs);


% split training and testing
ind_nz = randperm(num_nz);

fold = options.fold;
n_test = 
test_nz = 


n1 = size(Y,1);
n = nnz(Y); % number of non-zero elements
index = zeros(n,2);
index_zero = sparse(n1^2-n,2);
[index(:,1),index(:,2),Ynzero] = find(Y); % non-zero
[index_zero(:,1),index_zero(:,2),] = find(Y==0); % zero elements
Yzero = zeros(size(index_zero,1), 1);
trainingratio = options.trainingratio;
trainingtimes = options.trainingtimes;

Yobs_arr = cell(1,trainingtimes);
index_obs_arr =  cell(1,trainingtimes);
Ymiss_arr = cell(1,trainingtimes);
index_miss_arr = cell(1,trainingtimes);
for i=1: trainingtimes
    [Yobs_arr{i}, index_obs_arr{i}, Ymiss_arr{i}, index_miss_arr{i}] = ...
        feval(sel_algo,Ynzero, Yzero,index, index_zero, trainingratio);
end
save(strcat(Yname,'_links.mat'), 'Y','Yobs_arr','index_obs_arr','Ymiss_arr','index_miss_arr');

function [ Yobs, index_obs, Ymiss, index_miss ] = exp_onerun(Ynzero, Yzero,index, index_zero, trainingratio)
% for trainingain
[s_index, s_val ] = find(index(:,1)< index(:,2));

s_perm = randperm(length(s_index));
tr_index = s_perm(1: round(length(s_index)*trainingratio));% training index
test_index = setdiff(1:length(s_index), tr_index);% test index
half_trindex = index(s_index(tr_index)',:);
half_testindex = index(s_index(test_index)',:);
index_pos_tr = [half_trindex; half_trindex(:, [2 1])]; % index for observed
Yobspos = [Ynzero(s_index(tr_index)'); Ynzero(s_index(tr_index)')]; % observed y
index_miss = [half_testindex; half_testindex(:, [2 1])]; % missing index for observed values
Ymiss = [Ynzero(s_index(test_index)'); Ynzero(s_index(test_index)')]; % missing value in y

% % % %------- only use the left triangle links-------------
% % % index_pos_tr = half_trindex; 
% % % Yobspos = Ynzero(s_index(tr_index)'); % observed y
% % % index_miss = half_testindex;  % missing index for observed values
% % % Ymiss = Ynzero(s_index(test_index)'); % missing value in y

% % % check whether each user is included
% userSelected = unique(index_pos_tr(:,1));
% if length(userSelected)< (m1+m2)
%     userMissed = setdiff( [1:m1+m2], userSelected);
%     for j=1: length(userMissed)
%         indmiss = find(index(:,1)== userMissed(j));
%         index_pos_tr = [index_pos_tr; index(indmiss,:)];
%     end
% end


% if consider the unknown data
% for training
[s_index, s_val ] = find(index_zero(:,1)< index_zero(:,2));
s_perm = randperm(nnz(s_index));
tr_index = s_perm(1: round(nnz(s_index)* trainingratio));% training index
test_index = setdiff([1:length(s_index)], tr_index);% test index
half_trindex = index_zero(s_index(tr_index)',:); % look for zero-elements
half_testindex = index_zero(s_index(test_index)',:);
index_obs_neg = [half_trindex; half_trindex(:, [2 1])]; % index for observed
Yobs_neg = [Yzero(s_index(tr_index)'); Yzero(s_index(tr_index)')]; % observed y
index_miss_neg = [half_testindex; half_testindex(:, [2 1])]; % missing index
Ymiss_neg = [Yzero(s_index(test_index)'); Yzero(s_index(test_index)')]; % missing value in y

% % %------- only use the left triangle links-------------
% % index_obs_neg = half_trindex; % missing value in y
% % Yobs_neg = Yzero(s_index(tr_index)'); % observed y
% % index_miss_neg = half_testindex;  % missing index
% % Ymiss_neg = Yzero(s_index(test_index)');  % missing value in y


%% final training/testing
index_miss = ([index_miss; index_miss_neg]);
index_obs = ([index_pos_tr; index_obs_neg]);
Yobs = sparse([Yobspos; Yobs_neg]);
Ymiss = sparse([Ymiss; Ymiss_neg]);

% recover the orignal order!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
% first sort row, then sort column
[indv, indi] = sort(index_obs(:,1));
index_obs = index_obs(indi,:);
Yobs = Yobs(indi);
[indv, indi] = sort(index_obs(:,2));
index_obs = index_obs(indi,:);
Yobs = Yobs(indi);
% first sort row, then sort column
[indv, indi] = sort(index_miss(:,1));
index_miss = index_miss(indi,:);
Ymiss = sparse(Ymiss(indi));
[indv, indi] = sort(index_miss(:,2));
index_miss = (index_miss(indi,:));
Ymiss = sparse(Ymiss(indi));
% find non-zero elements in Ymiss
[nzi, nzj, nz_Ymiss] = find(Ymiss);

% save(strcat(Yname,'_links.mat'), 'Yobs_arr', 'index_obs_arr', 'Ymiss_arr', 'index_miss_arr' );

function [ Yobs, index_obs, Ymiss, index_miss ] = exp_onerun_unsym(Ynzero, Yzero, index, index_zero, trainingratio)
% for trainingain
%% for the non-zero part
perm = randperm(length(index));
tr_index = perm(1: round(length(index)*trainingratio));% training index
test_index = setdiff(1:length(index), tr_index);% test index

index_obs = index(tr_index,:); % index for observed
Yobs = Ynzero(tr_index);  % observed y
index_miss = index(test_index,:); % missing index for observed values
Ymiss = Ynzero(test_index);  % missing value in y

%% for the zero part
perm = randperm(length(index_zero));
nzero = length(Yzero);
tr_index = perm(1: round(nzero *trainingratio));% training index
test_index = setdiff(1:nzero, tr_index);% test index

index_zero_tr = index_zero(tr_index,:); % index for observed
Yobs_zero = Yzero(tr_index);  % observed y
index_miss_zero = index_zero(test_index,:); % missing index for observed values
Ymiss_zero = Yzero(test_index);  % missing value in y

Yobs = [Yobs; Yobs_zero];
index_obs = [index_obs; index_zero_tr];
Ymiss = [ Ymiss; Ymiss_zero];
index_miss = [ index_miss; index_miss_zero];