function [U,result] = test_baselines(data, model)
    nvec = size(data.Y);    
    num_mode = length(nvec);
    result = [];
    %HOSVD
    U = cell(num_mode,1);
    t = cell(num_mode, 1);
    for j = 1:num_mode
        U{j} = nvecs(data.Y, j, model.dim); %+ abs(randn(nvec(i), d)) * model.init_perturb;; %<-- Mode 1
        t{j} = pinv(U{j});
    end
    S = ttm(data.Y,t); %<-- Core    
    M = tensor(tensor(ttensor(S,U))); 
    %vsl = mean((data.Ymiss- M(data.subs)).^2);
    %fprintf('HOSVD MSE = %f\n', (mse));
    [~,~,~,val] = perfcurve(data.Ymiss, M(data.subs), 1);
    name = 'auc';
    fprintf('HOSVD auc = %f\n', (val));
    result = [result val];
    %nonnegative parafac
    P = cp_nmu(data.Y, model.dim);
    M = sptensor(tensor(P));
    %val = mean((data.Ymiss- M(data.subs)).^2);
    %fprintf('nonnegative PARAFAC mse = %f\n', (mse));
    [~,~,~,val] = perfcurve(data.Ymiss, M(data.subs), 1);
    name = 'auc';
    fprintf('nonnegative PARAFAC auc = %f\n', (val));    
    result = [result val];
    %TUCKER    
    P = tucker_als(data.Y, model.dim);
    M = sptensor(tensor(P));
    %val = mean((data.Ymiss- M(data.subs)).^2);
    %fprintf('Tucker MSE = %f\n', val);
    %result =[result val];
 
    [~,~,~,val] = perfcurve(data.Ymiss, M(data.subs), 1);
    name = 'auc';
    fprintf('Tucker auc = %f\n', (val));    
    result = [result val];

    
    %PARAFAC
    P = parafac_als(data.Y, model.dim);
    M = sptensor(tensor(P));
    %val = mean((data.Ymiss- M(data.subs)).^2);
    %fprintf('PARAFAC MSE = %f\n', val);
    %result =[result val];
    
    [~,~,~,val] = perfcurve(data.Ymiss, M(data.subs), 1);
    name = 'auc';
    fprintf('PARAFAC auc = %f\n', (val));    
    result = [result val];


        
end