function [M] = update_qM(M, Y, kernel, model)    
    tol = 1e-10;
    nvec = size(Y);
    nmod = length(nvec);
    var_total = model.var_total;
    loss = model.loss;
    sigma2 = model.sigma2;
    DD = tensor(ktensor(kernel.D));
    tau = 1;

    if strcmp(loss, 'Gauss') 
        DD =  DD ./ (tau*sigma2 + DD);
    else
        DD = DD ./ (tau + DD);
    end
    Vt = cell(nmod,1);
    for k=1: nmod
        Vt{k} = (kernel.V{k})';
    end

    if strcmp(loss, 'Gauss') 
        M = tensor(ttm( ttm(Y,Vt,1:nmod).*DD, kernel.V, 1:nmod));
    else %binary observation, using probit model
        M = tensor(M);
        beta = 2;
        for k = 1:var_total;
            P = (2*Y-1) .* tenfun(@(x) normpdf(x-beta), M ) ... %elemfun(M, @(x) normpdf(x-beta)) 
                ./ tenfun(@normcdf, 2*Y.*(M - beta) -M+beta  + tol );
            A = ttm(M+P,Vt,1:nmod).*DD;
            M = ttm( A, kernel.V, 1:nmod);        
        end
    end
end